## lomiri-ui-toolkit 1.3.6000~git20250930.d1286a4+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(lomiri-ui-toolkit VERSION 1.3.6000 LANGUAGES C CXX)
cmake_policy(SET CMP0048 NEW) # for ecm_setup_version

set(LOMIRI_UI_TOOLKIT_VERSION "5.5.0")
set(LOMIRI_UI_TOOLKIT_SOVERSION "5")
set(QT_VERSION_MAJOR 6)

find_package(QT NAMES Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core)
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS DBus Gui Qml Quick Svg Test Core5Compat)

find_package(Qt6 REQUIRED COMPONENTS ShaderTools)


find_package(LTTngUST)

find_package(PkgConfig REQUIRED)
pkg_check_modules(XCB REQUIRED xcb)
pkg_check_modules(GLIB REQUIRED glib-2.0)
pkg_check_modules(DBUS REQUIRED dbus-1)
pkg_check_modules(EGL REQUIRED egl)

#pkg_check_modules(QTORGANIZER REQUIRED Qt${QT_VERSION_MAJOR}Organizer)
#pkg_check_modules(QTSYSTEMINFO REQUIRED Qt${QT_VERSION_MAJOR}SystemInfo)

include(GNUInstallDirs)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

find_package(ECM "6.13.0" NO_MODULE)
set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH})

include(ECMGenerateExportHeader)
include(ECMGenerateHeaders)
include(CMakePackageConfigHelpers)
include(ECMSetupVersion)
include(ECMGeneratePkgConfigFile)

set(QML_PLUGIN_BASE_DIR "${CMAKE_INSTALL_LIBDIR}/qt${QT_VERSION_MAJOR}/qml/Lomiri")
set(QT_INSTALL_PLUGINS "${CMAKE_INSTALL_LIBDIR}/qt${QT_VERSION_MAJOR}/plugins")
set(LOMIRI_INSTALL_INCLUDEDIR "${CMAKE_INSTALL_INCLUDEDIR}/${CMAKE_LIBRARY_ARCHITECTURE}")
set(LOMIRI_INSTALL_CMAKEPACKAGEDIR "${CMAKE_INSTALL_LIBDIR}/cmake")

# Carried over from qmake
# FIXME: Fix bug 1606247 and enable the LomiriToolkit namespace.
# build LomiriToolkit without namespace
add_definitions(-DLOMIRITOOLKIT_NO_NAMESPACE)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
include(LomiriHeaders)

enable_testing()

add_subdirectory(apicheck)
if (LTTngUST_FOUND)
    add_subdirectory(app-launch-profiler)
endif()
add_subdirectory(lomiri-ui-toolkit-launcher)
add_subdirectory(src)
#add_subdirectory(tests)

=== apicheck/CMakeLists.txt ===
add_executable(apicheck
    apicheck.cpp
)

set_target_properties(apicheck PROPERTIES
    RUNTIME_OUTPUT_NAME "apicheck-qt${QT_VERSION_MAJOR}"
)

target_link_libraries(apicheck PRIVATE
    Qt::Core
    Qt::CorePrivate
    Qt::Gui
    Qt::GuiPrivate
    Qt::Qml
    Qt::QmlPrivate
    Qt::Quick
    Qt::QuickPrivate
    Qt::Test
)

install(
  TARGETS apicheck
  RUNTIME DESTINATION ${CMAKE_INSTALL_LIBEXECDIR}/lomiri-ui-toolkit
)

=== app-launch-profiler/CMakeLists.txt ===
set(CMAKE_INCLUDE_CURRENT_DIR ON)

add_executable(lomiri-app-launch-tracepoints
    app-launch-tracepoints.c app-launch-tracepoints.h
)

set_target_properties(lomiri-app-launch-tracepoints PROPERTIES
    RUNTIME_OUTPUT_NAME "lomiri-app-launch-tracepoints-qt${QT_VERSION_MAJOR}"
)

target_link_libraries(lomiri-app-launch-tracepoints PRIVATE
    LTTng::UST
    Qt::Core
    Qt::Gui
    dl
)

install(
  TARGETS lomiri-app-launch-tracepoints
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

install(
    PROGRAMS lomiri-app-launch-profiler-lttng
    DESTINATION ${CMAKE_INSTALL_BINDIR}
    RENAME "lomiri-app-launch-profiler-lttng-qt${QT_VERSION_MAJOR}"
)
install(
    PROGRAMS lomiri-appstart-profile
    DESTINATION ${CMAKE_INSTALL_BINDIR}
    RENAME "lomiri-appstart-profile-qt${QT_VERSION_MAJOR}"
)
install(
    PROGRAMS lomiri-appstart-test
    DESTINATION ${CMAKE_INSTALL_BINDIR}
    RENAME "lomiri-appstart-test-qt${QT_VERSION_MAJOR}"
)

=== lomiri-ui-toolkit-launcher/CMakeLists.txt ===
add_executable(lomiri-ui-toolkit-launcher
    launcher.cpp
)

set_target_properties(lomiri-ui-toolkit-launcher PROPERTIES
    RUNTIME_OUTPUT_NAME "lomiri-ui-toolkit-launcher-qt${QT_VERSION_MAJOR}"
)

target_link_libraries(lomiri-ui-toolkit-launcher PRIVATE
    Qt::CorePrivate
    Qt::GuiPrivate
    Qt::QuickPrivate
    Qt::Qml
    Qt::Test
    LomiriToolkit
    LomiriMetrics
)

install(
  TARGETS lomiri-ui-toolkit-launcher
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

=== src/CMakeLists.txt ===
set(CMAKE_INCLUDE_CURRENT_DIR ON)

add_subdirectory(LomiriGestures)
add_subdirectory(LomiriMetrics)
add_subdirectory(LomiriToolkit)
add_subdirectory(LomiriSystemInfo)

add_subdirectory(imports)

=== src/LomiriGestures/CMakeLists.txt ===
add_library(LomiriGestures SHARED
    candidateinactivitytimer.cpp candidateinactivitytimer_p.h
    damper.cpp damper_p.h
    debughelpers.cpp debughelpers_p.h
    lomirigesturesmodule.cpp lomirigesturesmodule.h
    lomirigesturesglobal.h
    pool_p.h
    timer.cpp timer_p.h
    timesource.cpp timesource_p.h
    touchownershipevent.cpp touchownershipevent_p.h
    touchregistry.cpp touchregistry_p.h
    ucswipearea.cpp ucswipearea_p.h
    ucswipearea_p_p.h
    unownedtouchevent.cpp unownedtouchevent_p.h
)
add_library(LomiriGestures::LomiriGestures ALIAS LomiriGestures)

set_target_properties(LomiriGestures PROPERTIES
    VERSION     ${LOMIRI_UI_TOOLKIT_VERSION}
    SOVERSION   ${LOMIRI_UI_TOOLKIT_SOVERSION}
    OUTPUT_NAME "LomiriGestures-Qt6"
    EXPORT_NAME "LomiriGestures-Qt6"
)

target_link_libraries(LomiriGestures PRIVATE
    Qt::CorePrivate
    Qt::GuiPrivate
    Qt::QmlPrivate
    Qt::QuickPrivate
)

lomiri_target_prepare_headers(LomiriGestures SUBDIRECTORY LomiriGestures-Qt6)

ecm_generate_export_header(LomiriGestures
    VERSION ${LOMIRI_UI_TOOLKIT_VERSION}
    BASE_NAME LomiriGestures
)

ecm_generate_headers(LomiriGestures_FORWARDING_HEADERS
    HEADER_NAMES
        LomiriGesturesModule
    COMMON_HEADER LomiriGestures
)

install(TARGETS LomiriGestures
    EXPORT LomiriGesturesTargets
    LIBRARY DESTINATION ${CMAKE_INSTALL_FULL_LIBDIR}
)

set(CMAKECONFIG_INSTALL_DIR "${LOMIRI_INSTALL_CMAKEPACKAGEDIR}/LomiriGestures-Qt6")
set(LomiriGestures_VERSION_HEADER "${CMAKE_CURRENT_BINARY_DIR}/lomirigesturesversion.h")

ecm_setup_version(
    PROJECT
    VARIABLE_PREFIX LomiriGestures
    VERSION_HEADER "${LomiriGestures_VERSION_HEADER}"
    PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/LomiriGestures-Qt6ConfigVersion.cmake"
    SOVERSION ${LOMIRI_UI_TOOLKIT_SOVERSION}
)

lomiri_target_install_headers(LomiriGestures
    EXTRA_FILES
        ${LomiriGestures_FORWARDING_HEADERS}
        "${LomiriGestures_VERSION_HEADER}"
    DESTINATION ${LOMIRI_INSTALL_INCLUDEDIR}/LomiriGestures-Qt6
)

ecm_generate_pkgconfig_file(BASE_NAME LomiriGestures-Qt6
    INCLUDE_INSTALL_DIR ${LOMIRI_INSTALL_INCLUDEDIR}/LomiriGestures-Qt6
    DEPS "Qt6CorePrivate Qt6GuiPrivate Qt6QmlPrivate Qt6QuickPrivate"
    INSTALL
)

configure_package_config_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/LomiriGestures-Qt6Config.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/LomiriGestures-Qt6Config.cmake"
    INSTALL_DESTINATION ${CMAKECONFIG_INSTALL_DIR}
    PATH_VARS CMAKE_INSTALL_PREFIX
)

install(FILES
    "${CMAKE_CURRENT_BINARY_DIR}/LomiriGestures-Qt6Config.cmake"
    "${CMAKE_CURRENT_BINARY_DIR}/LomiriGestures-Qt6ConfigVersion.cmake"
    DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
    COMPONENT Devel
)

install(EXPORT LomiriGesturesTargets
    DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
    FILE LomiriGestures-Qt6Targets.cmake
    NAMESPACE LomiriGestures::
)

=== src/LomiriMetrics/CMakeLists.txt ===
set(QML_PLUGIN_DIR "${QML_PLUGIN_BASE_DIR}/PerformanceMetrics")

add_library(LomiriMetrics SHARED
    applicationmonitor.cpp applicationmonitor.h applicationmonitor_p.h
    bitmaptext.cpp bitmaptext_p.h
    bitmaptextfont_p.h
    events.cpp events.h events_p.h
    gputimer.cpp gputimer_p.h
    logger.cpp logger.h logger_p.h
    lomirimetricsglobal.cpp lomirimetricsglobal.h lomirimetricsglobal_p.h
    overlay.cpp overlay_p.h
)
add_library(LomiriMetrics::LomiriMetrics ALIAS LomiriMetrics)

target_compile_definitions(LomiriMetrics PRIVATE
    EGL_NO_X11
    MESA_EGL_NO_X11_HEADERS
)

set_target_properties(LomiriMetrics PROPERTIES
    VERSION     ${LOMIRI_UI_TOOLKIT_VERSION}
    SOVERSION   ${LOMIRI_UI_TOOLKIT_SOVERSION}
    OUTPUT_NAME "LomiriMetrics-Qt6"
    EXPORT_NAME "LomiriMetrics-Qt6"
)

target_link_libraries(LomiriMetrics PRIVATE
    Qt::CorePrivate
    Qt::GuiPrivate
    Qt::QuickPrivate
    dl
    ${EGL_LIBRARIES}
)

ecm_generate_export_header(LomiriMetrics
    VERSION ${LOMIRI_UI_TOOLKIT_VERSION}
    BASE_NAME LomiriMetrics
)

if(LTTngUST_FOUND)
    target_compile_definitions(LomiriMetrics PRIVATE
        LTTNG_PLUGIN_BUILD_PATH=\"${CMAKE_CURRENT_BINARY_DIR}/lttng/libumlttng.so\"
        LTTNG_PLUGIN_INSTALL_PATH=\"${QT_INSTALL_PLUGINS}/lomiri/metrics/libumlttng.so\"
    )

    add_subdirectory(lttng)
endif()

lomiri_target_prepare_headers(LomiriMetrics SUBDIRECTORY LomiriMetrics-Qt6)

# install
install(TARGETS LomiriMetrics
    EXPORT LomiriMetricsTargets
    LIBRARY DESTINATION ${CMAKE_INSTALL_FULL_LIBDIR}
)

set(CMAKECONFIG_INSTALL_DIR "${LOMIRI_INSTALL_CMAKEPACKAGEDIR}/LomiriMetrics-Qt6")
set(LomiriMetrics_VERSION_HEADER "${CMAKE_CURRENT_BINARY_DIR}/lomirimetricsversion.h")

ecm_setup_version(
    PROJECT
    VARIABLE_PREFIX LomiriMetrics
    VERSION_HEADER "${LomiriMetrics_VERSION_HEADER}"
    PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/LomiriMetrics-Qt6ConfigVersion.cmake"
    SOVERSION ${LOMIRI_UI_TOOLKIT_SOVERSION}
)

lomiri_target_install_headers(LomiriMetrics
    EXTRA_FILES "${LomiriMetrics_VERSION_HEADER}"
    DESTINATION ${LOMIRI_INSTALL_INCLUDEDIR}/LomiriMetrics-Qt6
)

ecm_generate_pkgconfig_file(BASE_NAME LomiriMetrics-Qt6
    INCLUDE_INSTALL_DIR ${LOMIRI_INSTALL_INCLUDEDIR}/LomiriMetrics-Qt6
    DEPS "Qt6CorePrivate Qt6GuiPrivate Qt6QuickPrivate dl egl"
    INSTALL
)

configure_package_config_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/LomiriMetrics-Qt6Config.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/LomiriMetrics-Qt6Config.cmake"
    INSTALL_DESTINATION  ${CMAKECONFIG_INSTALL_DIR}
    PATH_VARS CMAKE_INSTALL_PREFIX
)

install(FILES
    "${CMAKE_CURRENT_BINARY_DIR}/LomiriMetrics-Qt6Config.cmake"
    "${CMAKE_CURRENT_BINARY_DIR}/LomiriMetrics-Qt6ConfigVersion.cmake"
    DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
    COMPONENT Devel
)

install(EXPORT LomiriMetricsTargets
    DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
    FILE LomiriMetrics-Qt6Targets.cmake
    NAMESPACE LomiriMetrics::
)

=== src/LomiriSystemInfo/CMakeLists.txt ===
pkg_check_modules(UDEV REQUIRED libudev)
pkg_check_modules(EVDEV REQUIRED libevdev)
pkg_check_modules(BLUEZ REQUIRED bluez)
#pkg_check_modules(MIRCLIENT REQUIRED mir1client)

add_library(LomiriSystemInfo SHARED
    linux/lomiribatteryinfo_upower.cpp
    linux/lomiribatteryinfo_upower_p.h
    linux/lomirideviceinfo_linux.cpp
    linux/lomirideviceinfo_linux_p.h
    linux/lomiridevicekitservice_linux.cpp
    linux/lomiridevicekitservice_linux_p.h
    linux/lomiriinputinfomanagerudev.cpp
    linux/lomiriinputinfomanagerudev_p.h
    #linux/lomiriinputinfomanagermir.cpp
    #linux/lomiriinputinfomanagermir_p.h
    linux/lomirinetworkinfo_linux.cpp
    linux/lomirinetworkinfo_linux_p.h
    linux/lomiriofonowrapper.cpp
    linux/lomiriofonowrapper_p.h
    linux/lomiriscreensaver_mir.cpp
    linux/lomiriscreensaver_mir_p.h
    linux/lomiriudevwrapper.cpp
    linux/lomiriudevwrapper_p.h
    lomiribatteryinfo.cpp
    lomiribatteryinfo.h
    lomirideviceinfo.cpp
    lomirideviceinfo.h
    lomiriinputinfo.cpp
    lomiriinputinfo.h
    lomiriinputinfomanager.cpp
    lomiriinputinfomanager_p.h
    lomirinetworkinfo.cpp
    lomirinetworkinfo.h
    lomiriscreensaver.cpp
    lomiriscreensaver.h
    lomirisysteminfoglobal.h
    lomirisysteminfoglobal_p.h
)
add_library(LomiriSystemInfo::LomiriSystemInfo ALIAS LomiriSystemInfo)

set_target_properties(LomiriSystemInfo PROPERTIES
    VERSION     ${LOMIRI_UI_TOOLKIT_VERSION}
    SOVERSION   ${LOMIRI_UI_TOOLKIT_SOVERSION}
    OUTPUT_NAME "LomiriSystemInfo-Qt6"
    EXPORT_NAME "LomiriSystemInfo-Qt6"
)

target_include_directories(LomiriSystemInfo
    PUBLIC
        #${MIRCLIENT_INCLUDE_DIRS}
        ${EVDEV_INCLUDE_DIRS}
)

target_link_libraries(LomiriSystemInfo
    Qt::Core
    Qt::Network
    Qt::Gui
    # qpa
    Qt::GuiPrivate
    Qt::DBus

    ${UDEV_LIBRARIES}
    ${EVDEV_LIBRARIES}
    ${BLUEZ_LIBRARIES}
    #${MIRCLIENT_LIBRARIES}
)

# define QT_UNITY8
target_compile_definitions(LomiriSystemInfo
    PRIVATE
        QT_UNITY8
        QT_NO_MIR
)

lomiri_target_prepare_headers(LomiriSystemInfo SUBDIRECTORY LomiriSystemInfo-Qt6)

# install
ecm_generate_export_header(LomiriSystemInfo
    VERSION ${LOMIRI_UI_TOOLKIT_VERSION}
    BASE_NAME LomiriSystemInfo
)

ecm_generate_headers(LomiriSystemInfo_FORWARDING_HEADERS
    HEADER_NAMES
        LomiriBatteryInfo
        LomiriInputInfo,LomiriInputDevice,LomiriInputInfoManager
        LomiriDeviceInfo
        LomiriScreenSaver
        LomiriNetworkInfo
    COMMON_HEADER LomiriSystemInfo
)

install(TARGETS LomiriSystemInfo
    EXPORT LomiriSystemInfoTargets
    LIBRARY DESTINATION ${CMAKE_INSTALL_FULL_LIBDIR}
)

set(CMAKECONFIG_INSTALL_DIR "${LOMIRI_INSTALL_CMAKEPACKAGEDIR}/LomiriSystemInfo-Qt6")
set(LomiriSystemInfo_VERSION_HEADER "${CMAKE_CURRENT_BINARY_DIR}/lomirisysteminfoversion.h")

ecm_setup_version(
    PROJECT
    VARIABLE_PREFIX LomiriSystemInfo
    VERSION_HEADER "${LomiriSystemInfo_VERSION_HEADER}"
    PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/LomiriSystemInfo-Qt6ConfigVersion.cmake"
    SOVERSION ${LOMIRI_UI_TOOLKIT_SOVERSION}
)

lomiri_target_install_headers(LomiriSystemInfo
    EXTRA_FILES
        ${LomiriSystemInfo_FORWARDING_HEADERS}
        "${LomiriSystemInfo_VERSION_HEADER}"
    DESTINATION "${LOMIRI_INSTALL_INCLUDEDIR}/LomiriSystemInfo-Qt6"
)

ecm_generate_pkgconfig_file(BASE_NAME LomiriSystemInfo-Qt6
    INCLUDE_INSTALL_DIR ${LOMIRI_INSTALL_INCLUDEDIR}/LomiriSystemInfo-Qt6
    DEPS "Qt6Core Qt6Network Qt6Gui Qt6GuiPrivate Qt6DBus libudev libevdev"
    INSTALL
)

configure_package_config_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/LomiriSystemInfo-Qt6Config.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/LomiriSystemInfo-Qt6Config.cmake"
    INSTALL_DESTINATION ${CMAKECONFIG_INSTALL_DIR}
    PATH_VARS CMAKE_INSTALL_PREFIX
)

install(FILES
    "${CMAKE_CURRENT_BINARY_DIR}/LomiriSystemInfo-Qt6Config.cmake"
    "${CMAKE_CURRENT_BINARY_DIR}/LomiriSystemInfo-Qt6ConfigVersion.cmake"
    DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
    COMPONENT Devel
)

install(EXPORT LomiriSystemInfoTargets
    DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
    FILE LomiriSystemInfo-Qt6Targets.cmake
    NAMESPACE LomiriSystemInfo::
)

=== src/LomiriToolkit/CMakeLists.txt ===
set(QML_PLUGIN_DIR "${CMAKE_INSTALL_LIBDIR}/qt${QT_VERSION_MAJOR}/qml/Lomiri/Components")

pkg_check_modules(X11 REQUIRED x11)
pkg_check_modules(XCB REQUIRED xcb)
pkg_check_modules(XI REQUIRED xi)

set(MOUSE_TOUCH_ADAPTOR_SOURCES
    mousetouchadaptor_x11.cpp
)

set(MOUSE_TOUCH_ADAPTOR_DEFINES
    LOMIRITOOLKIT_ENABLE_X11_TOUCH_EMULATION
)

set(MOUSE_TOUCH_ADAPTOR_LIBS
    ${X11_LIBRARIES}
    ${XCB_LIBRARIES}
    ${XI_LIBRARIES}
)

add_library(LomiriToolkit SHARED
    ${MOUSE_TOUCH_ADAPTOR_SOURCES}
    actionlist.cpp actionlist_p.h
    adapters/actionsproxy_p.cpp adapters/actionsproxy_p.h
    #adapters/alarmsadapter_p.h
    #adapters/alarmsadapter_organizer.cpp
    adapters/dbuspropertywatcher_p.cpp adapters/dbuspropertywatcher_p.h
    #alarmmanager_p.cpp alarmmanager_p.h alarmmanager_p_p.h
    asyncloader.cpp asyncloader_p.h
    asyncloader_p_p.h
    colorutils.cpp colorutils_p.h
    exclusivegroup.cpp exclusivegroup_p.h
    filterbehavior.cpp filterbehavior_p.h
    i18n.cpp i18n_p.h
    inversemouseareatype.cpp inversemouseareatype_p.h
    label_p.h
    listener.cpp listener_p.h
    livetimer.cpp livetimer_p.cpp livetimer_p.h
    livetimer_p_p.h
    lomirithemeiconprovider.cpp lomirithemeiconprovider_p.h
    lomiritoolkitglobal.h
    lomiritoolkitmodule.cpp lomiritoolkitmodule.h
    menu.cpp menu_p.h
    menu_p_p.h
    menubar.cpp menubar_p.h
    menubar_p_p.h
    menugroup.cpp menugroup_p.h
    mousetouchadaptor.cpp mousetouchadaptor_p.h
    mousetouchadaptor_p_p.h
    privates/appheaderbase.cpp privates/appheaderbase_p.h
    privates/frame.cpp privates/frame_p.h
    privates/listitemdragarea.cpp privates/listitemdragarea_p.h
    privates/listitemdraghandler.cpp privates/listitemdraghandler_p.h
    privates/listitemexpansion.cpp
    privates/listitemselection.cpp privates/listitemselection_p.h
    privates/listviewextensions.cpp privates/listviewextensions_p.h
    privates/splitviewhandler.cpp privates/splitviewhandler_p.h
    privates/threelabelsslot_p.cpp privates/threelabelsslot_p.h
    privates/ucpagewrapper.cpp privates/ucpagewrapper_p.h
    privates/ucpagewrapper_p_p.h
    privates/ucpagewrapperincubator.cpp privates/ucpagewrapperincubator_p.h
    privates/ucscrollbarutils.cpp privates/ucscrollbarutils_p.h
    propertychange.cpp propertychange_p.h
    qquickclipboard.cpp qquickclipboard_p.h
    qquickclipboard_p_p.h
    qquickmimedata.cpp qquickmimedata_p.h
    quickutils.cpp quickutils_p.h
    sortbehavior.cpp sortbehavior_p.h
    sortfiltermodel.cpp sortfiltermodel_p.h
    splitview.cpp splitview_p.h
    splitview_p_p.h
    splitviewlayout.cpp
    statesaverbackend_p.cpp statesaverbackend_p.h
    timeutils_p.h
    tree.cpp tree_p.h
    ucabstractbutton.cpp ucabstractbutton_p.h
    ucabstractbutton_p_p.h
    ucaction.cpp ucaction_p.h
    ucactioncontext.cpp ucactioncontext_p.h
    ucactionitem.cpp ucactionitem_p.h
    ucactionitem_p_p.h
    ucactionmanager.cpp ucactionmanager_p.h
    #ucalarm.cpp ucalarm_p.h ucalarm_p_p.h
    #ucalarmmodel.cpp ucalarmmodel_p.h
    ucapplication.cpp ucapplication_p.h
    ucargument.cpp ucargument_p.h
    ucarguments.cpp ucarguments_p.h
    ucbottomedge.cpp ucbottomedge_p.h
    ucbottomedge_p_p.h
    ucbottomedgehint.cpp ucbottomedgehint_p.h
    ucbottomedgehint_p_p.h
    ucbottomedgeregion.cpp ucbottomedgeregion_p.h
    ucbottomedgeregion_p_p.h
    ucbottomedgestyle.cpp ucbottomedgestyle_p.h
    ucdefaulttheme.cpp ucdefaulttheme_p.h
    ucdeprecatedtheme.cpp ucdeprecatedtheme_p.h
    ucfontutils.cpp ucfontutils_p.h
    uchaptics.cpp uchaptics_p.h
    ucheader.cpp ucheader_p.h
    ucimportversionchecker_p.cpp ucimportversionchecker_p.h
    ucinversemouse_p.h
    uclabel.cpp uclabel_p.h
    uclistitem.cpp uclistitem_p.h
    uclistitem_p_p.h
    uclistitemactions.cpp uclistitemactions_p.h
    uclistitemactions_p_p.h
    uclistitemlayout.cpp uclistitemlayout_p.h
    uclistitemstyle.cpp uclistitemstyle_p.h
    uclomirianimation.cpp uclomirianimation_p.h
    uclomirishape.cpp uclomirishape_p.h
    uclomirishapeoverlay.cpp uclomirishapeoverlay_p.h
    uclomirishapetextures.cpp uclomirishapetextures_p.h
    ucmainviewbase.cpp ucmainviewbase_p.h
    ucmainviewbase_p_p.h
    ucmainwindow.cpp ucmainwindow_p.h
    ucmainwindow_p_p.h
    ucmargins_p.h
    ucmathutils.cpp ucmathutils_p.h
    ucmouse_p.h
    ucmousefilters.cpp
    ucnamespace.cpp ucnamespace_p.h
    ucpagetreenode.cpp ucpagetreenode_p.h
    ucpagetreenode_p_p.h
    ucperformancemonitor.cpp ucperformancemonitor_p.h
    ucproportionalshape.cpp ucproportionalshape_p.h
    ucqquickimageextension.cpp ucqquickimageextension_p.h
    ucscalingimageprovider.cpp ucscalingimageprovider_p.h
    ucserviceproperties.cpp ucserviceproperties_p.h
    ucserviceproperties_p_p.h
    ucslotslayout.cpp ucslotslayout_p.h
    ucslotslayout_p_p.h
    ucstatesaver.cpp ucstatesaver_p.h
    ucstatesaver_p_p.h
    ucstyleditembase.cpp ucstyleditembase_p.h
    ucstyleditembase_p_p.h
    ucstylehints.cpp ucstylehints_p.h
    uctheme.cpp uctheme_p.h
    ucthemingextension.cpp ucthemingextension_p.h
    ucunits.cpp ucunits_p.h
    ucurihandler.cpp ucurihandler_p.h
    ucviewitemsattached.cpp
    unixsignalhandler_p.cpp unixsignalhandler_p.h
)
add_library(LomiriToolkit::LomiriToolkit ALIAS LomiriToolkit)

# -fpermissive
target_compile_options(LomiriToolkit PRIVATE
    -fpermissive
)

set_target_properties(LomiriToolkit PROPERTIES
    VERSION     ${LOMIRI_UI_TOOLKIT_VERSION}
    SOVERSION   ${LOMIRI_UI_TOOLKIT_SOVERSION}
    OUTPUT_NAME "LomiriToolkit-Qt6"
    EXPORT_NAME "LomiriToolkit-Qt6"
)

target_link_libraries(LomiriToolkit PUBLIC
    LomiriGestures
    LomiriMetrics
    LomiriSystemInfo
    Qt::CorePrivate
    Qt::DBus
    Qt::GuiPrivate
    Qt::QmlPrivate
    Qt::QuickPrivate
    Qt::Svg
    Qt::Test
 #   Qt::Organizer
    Qt6::Core5Compat

    ${DBUS_LIBRARIES}
    ${GLIB_LIBRARIES}
    ${MOUSE_TOUCH_ADAPTOR_LIBS}
)

ecm_generate_export_header(LomiriToolkit
    VERSION ${LOMIRI_UI_TOOLKIT_VERSION}
    BASE_NAME LomiriToolkit
)

ecm_generate_headers(LomiriToolkit_FORWARDING_HEADERS
    HEADER_NAMES
        LomiriToolkitModule
    COMMON_HEADER LomiriToolkit
)

target_include_directories(LomiriToolkit
    PRIVATE
        # glib
        ${GLIB_INCLUDE_DIRS}
)

target_compile_definitions(LomiriToolkit PRIVATE
    ${MOUSE_TOUCH_ADAPTOR_DEFINES}
)

lomiri_target_prepare_headers(LomiriToolkit SUBDIRECTORY LomiriToolkit-Qt6)

qt6_add_shaders(LomiriToolkit "LomiriToolkit_shaders"
    BATCHABLE
    PRECOMPILE
    OPTIMIZED
    PREFIX
        "/uc"
    FILES
        "privates/shaders/frame.vert"
        "privates/shaders/frame.frag"
        "shaders/shape.vert"
        "shaders/shape.frag"
        "shaders/shape_mipmap.frag"
        "shaders/shapeoverlay.vert"
        "shaders/shapeoverlay.frag"
        "shaders/shapeoverlay_mipmap.frag"
)

# install
install(TARGETS LomiriToolkit
    EXPORT LomiriToolkitTargets
    LIBRARY DESTINATION ${CMAKE_INSTALL_FULL_LIBDIR}
)

set(CMAKECONFIG_INSTALL_DIR "${LOMIRI_INSTALL_CMAKEPACKAGEDIR}/LomiriToolkit-Qt6")
set(LomiriToolkit_VERSION_HEADER "${CMAKE_CURRENT_BINARY_DIR}/lomiritoolkitversion.h")

ecm_setup_version(
    PROJECT
    VARIABLE_PREFIX LomiriToolkit
    VERSION_HEADER "${LomiriToolkit_VERSION_HEADER}"
    PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/LomiriToolkit-Qt6ConfigVersion.cmake"
    SOVERSION ${LOMIRI_UI_TOOLKIT_SOVERSION}
)

lomiri_target_install_headers(LomiriToolkit
    EXTRA_FILES
        ${LomiriToolkit_FORWARDING_HEADERS}
        "${LomiriToolkit_VERSION_HEADER}"
    DESTINATION "${LOMIRI_INSTALL_INCLUDEDIR}/LomiriToolkit-Qt6"
)

ecm_generate_pkgconfig_file(BASE_NAME LomiriToolkit-Qt6
    INCLUDE_INSTALL_DIR ${LOMIRI_INSTALL_INCLUDEDIR}/LomiriToolkit-Qt6
    DEPS "Qt6CorePrivate Qt6DBus Qt6GuiPrivate Qt6QmlPrivate Qt6QuickPrivate Qt6Svg Qt6Test Qt6Core5Compat LomiriSystemInfo glib-2.0 dbus-1 x11 xcb xi"
    INSTALL
)

configure_package_config_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/LomiriToolkit-Qt6Config.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/LomiriToolkit-Qt6Config.cmake"
    INSTALL_DESTINATION  ${CMAKECONFIG_INSTALL_DIR}
    PATH_VARS CMAKE_INSTALL_PREFIX
)

install(FILES
    "${CMAKE_CURRENT_BINARY_DIR}/LomiriToolkit-Qt6Config.cmake"
    "${CMAKE_CURRENT_BINARY_DIR}/LomiriToolkit-Qt6ConfigVersion.cmake"
    DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
    COMPONENT Devel
)

install(EXPORT LomiriToolkitTargets
    DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
    FILE LomiriToolkit-Qt6Targets.cmake
    NAMESPACE LomiriToolkit::
)

=== src/LomiriMetrics/lttng/CMakeLists.txt ===
add_library(umlttng MODULE
    lttng.c
    tracepoints.c
)

target_link_libraries(umlttng PRIVATE
    LTTng::UST
)

install(TARGETS umlttng
    LIBRARY DESTINATION "${QT_INSTALL_PLUGINS}/lomiri/metrics"
)

=== src/LomiriToolkit/tools/CMakeLists.txt ===
add_executable(createshapetextures
    createshapetextures.cpp
)
target_link_libraries(createshapetextures PRIVATE
    Qt::Core
    Qt::Gui
    Qt::Svg
)

target_compile_options(createshapetextures
    -Wno-unused-variable
)

=== src/imports/Components/CMakeLists.txt ===
add_library(LomiriComponents MODULE
    plugin/plugin.cpp
)

target_link_libraries(LomiriComponents PRIVATE
    LomiriToolkit
    Qt::Core
    Qt::CorePrivate
    Qt::Gui
    Qt::GuiPrivate
    Qt::Qml
    Qt::Quick
)

qt6_add_shaders(LomiriComponents "LomiriComponents_shaders"
    PRECOMPILE
    OPTIMIZED
    FILES
        "1.0/shaders/colorizeimage.frag"
        "1.2/shaders/colourshader.frag"
        "Themes/Ambiance/shaders/magnifier.frag"
        "Themes/Ambiance/shaders/partialcolorize.frag"
)

set(QML_PLUGIN_DIR "${QML_PLUGIN_BASE_DIR}/Components")

# Install the QML files
install(TARGETS LomiriComponents
    DESTINATION ${QML_PLUGIN_DIR}
)

file(GLOB ARTWORK_FILES "artwork/*")

set(QML_FILES
    "2.0/ActionBar.qml"
    "2.0/ActivityIndicator.qml"
    "2.0/AdaptivePageLayout.qml"
    "2.0/AnimatedItem.qml"
    "2.0/AppHeader.qml"
    "2.0/Button.qml"
    "2.0/Captions.qml"
    "2.0/CheckBox.qml"
    "2.0/ComboButton.qml"
    "2.0/CrossFadeImage.qml"
    "2.0/dateUtils.js"
    "2.0/DraggingArea.qml"
    "2.0/InputHandler.qml"
    "2.0/MainView.qml"
    "2.0/OptionSelectorDelegate.qml"
    "2.0/OptionSelector.qml"
    "2.0/OrientationHelper.qml"
    "2.0/PageHeadConfiguration.qml"
    "2.0/PageHeadSections.qml"
    "2.0/PageHeadState.qml"
    "2.0/Page.qml"
    "2.0/PageStack.qml"
    "2.0/pageUtils.js"
    "2.0/Panel.qml"
    "2.0/ProgressBar.qml"
    "2.0/PullToRefresh.qml"
    "2.0/Scrollbar.qml"
    "2.0/Sections.qml"
    "2.0/Slider.qml"
    "2.0/Switch.qml"
    "2.0/TabBar.qml"
    "2.0/Tab.qml"
    "2.0/Tabs.qml"
    "2.0/TextArea.qml"
    "2.0/TextCursor.qml"
    "2.0/TextField.qml"
    "2.0/TextInputPopover.qml"
    "2.0/Toolbar.qml"
    "2.0/ToolbarButton.qml"
    "2.0/ToolbarItems.qml"
    "2.0/LomiriColors.qml"
    "2.0/LomiriListView.qml"
    "2.0/LomiriNumberAnimation.qml"
    "2.0/ListItemPopover.qml"
    "2.0/PageColumn.qml"
    "2.0/PageColumnsLayout.qml"
    "2.0/ProgressionSlot.qml"
    "2.0/ScrollView.qml"
    "2.0/PageHeader.qml"
    "2.0/Haptics.qml"
    "2.0/Icon.qml"
    "2.0/AbstractButton.qml"
    "2.0/ActionList.qml"
    "2.0/Label.qml"
    "2.0/MainViewBase.qml"
    "2.0/PageTreeNode.qml"
    "2.0/PageWrapper.qml"
)

install(FILES ${ARTWORK_FILES} DESTINATION ${QML_PLUGIN_DIR}/artwork)
install(FILES ${QML_FILES} DESTINATION ${QML_PLUGIN_DIR}/2.0)
install(FILES "qmldir-qt6" DESTINATION ${QML_PLUGIN_DIR}/ RENAME "qmldir")
    

add_subdirectory(Labs)
add_subdirectory(ListItems)
add_subdirectory(Pickers)
add_subdirectory(Popups)
add_subdirectory(Styles)
add_subdirectory(Themes)

=== debian/changelog ===
lomiri-ui-toolkit (1.3.6000~git20250930.d1286a4+dfsg-1~exp1) experimental; urgency=medium

  * New upstream release preview / Git snapshot.
  * debian/copyright:
    + Update copyright attributions.
  * debian/patches:
    + Drop 0001_Don-t-use-LOMIRI_UI_TOOLKIT_VERSION-for-PROJECT_VERS.patch.
      Applied upstream.
    + Drop 0002_src-lib-CMakeLists.txt-Use-qt6-not-Qt6-as-library-na.patch.
      Applied upstream.
    + Rebase 2004_dont_do_header_check_will_fail_on_s390x.patch.
  * debian/rules:
    + Don't clean-up sync.profile anymore during clean target.
    + Remove private headers after dh_auto_install.
  * debian/*.install:
    + Adjust to path changes in this upstream Git snapshot.

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 01 Oct 2025 21:43:43 +0200

=== debian/control ===
Source: lomiri-ui-toolkit
Priority: optional
Section: libs
Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
Uploaders:
 Mike Gabriel <sunweaver@debian.org>,
 Marius Gripsgard <marius@ubports.com>,
Build-Depends: accountsservice <!nocheck>,
               cmake,
               lomiri-schemas <!nocheck>,
               dbus <!nocheck>,
               dbus-test-runner <!nocheck>,
               debhelper-compat (= 13),
               gdb,
               dh-sequence-python3,
               extra-cmake-modules (>= 6.13.0),
               fonts-noto-core,
               fonts-noto-mono,
               libbluetooth-dev,
               libdbus-1-dev,
               libevdev-dev,
               libfontconfig-dev,
               libfreetype-dev,
               libgl1-mesa-dri,
               libgles2-mesa-dev,
               libglib2.0-dev,
               libinput-dev,
               liblttng-ust-dev,
               libmtdev-dev,
               libqt5sql5-sqlite,
               libqt5svg5-dev,
               libudev-dev,
               libx11-dev,
               libxcb1-dev,
               libxi-dev,
               libxkbcommon-dev,
               libxrender-dev,
               licensecheck,
               locales,
               lsb-release,
               pycodestyle <!cross>,
               python3-all:any,
               python3-debian <!cross>,
               python3-sphinx <!cross>,
               python3-setuptools <!cross>,
               qml6-module-qt-labs-settings,
               qml6-module-ktactilefeedback,
               qml6-module-qt5compat-graphicaleffects,
               qml6-module-qtqml-models,
               qml6-module-qtqml-workerscript,
               qml6-module-qtquick-layouts,
               qml6-module-qtquick-localstorage,
               qml6-module-qtquick-window,
               qml6-module-qtquick,
               qml6-module-qttest,
               qml-module-qt-labs-settings,
               qml-module-qtfeedback,
               qml-module-qtgraphicaleffects,
               qml-module-qtqml-models2,
               qml-module-qtquick-layouts,
               qml-module-qtquick-localstorage,
               qml-module-qtquick-window2,
               qml-module-qtquick2,
               qml-module-qttest,
               qt6-5compat-dev,
               qt6-base-dev,
               qt6-base-private-dev,
               qt6-declarative-dev,
               qt6-declarative-private-dev,
               qt6-shadertools-dev,
               qt6-svg-dev,
               qt6-tools-dev,
#               qt6-pim-dev,
               qtbase5-dev,
               qtbase5-private-dev,
               qtdeclarative5-dev (>= 5.12.8~),
               qtdeclarative5-dev-tools,
               qtdeclarative5-doc-html <!cross>,
               qtdeclarative5-private-dev,
               qtmultimedia5-doc-html <!cross>,
               qtpim5-dev (>= 5.0~git20171109.0bd985b~),
               qtscript5-doc-html <!cross>,
               qtsvg5-doc-html <!cross>,
               qtsystems5-dev,
               qtsystems5-private-dev,
               qttools5-dev-tools,
               suru-icon-theme (>= 20.05~),
               uuid-runtime,
               xvfb <!nocheck>,
               xauth <!nocheck>,
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://gitlab.com/ubports/development/core/lomiri-ui-toolkit/
Vcs-Git: https://salsa.debian.org/ubports-team/lomiri-ui-toolkit.git
Vcs-Browser: https://salsa.debian.org/ubports-team/lomiri-ui-toolkit/

Package: qml-module-lomiri-components
Architecture: any
Multi-Arch: same
Depends: ${fonts-ubuntu},
         ${fonts-noto},
         liblomirigestures5t64 (= ${binary:Version}),
         liblomirimetrics5t64 (= ${binary:Version}),
         liblomiritoolkit5t64 (= ${binary:Version}),
         libqt5svg5,
         lomiri-ui-toolkit-common (>= ${source:Version}),
         lomiri-ui-toolkit-common (<< ${source:Version}.1~),
         lomiri-ui-toolkit-theme (= ${binary:Version}),
         qml-module-lomiri-components-labs,
         qml-module-lomiri-performancemetrics,
         qml-module-qtfeedback,
         qml-module-qtgraphicaleffects,
         qml-module-qtquick-layouts,
         qml-module-qtquick-window2,
         qml-module-qtquick2,
         suru-icon-theme (>= 20.05~),
         ${misc:Depends},
         ${shlibs:Depends},
Conflicts: qt-components-lomiri,
Breaks: qtdeclarative5-lomiri-ui-toolkit-plugin (<< 1.3.3000~),
Replaces: qt-components-lomiri,
          qtdeclarative5-lomiri-ui-toolkit-plugin (<< 1.3.3000~),
Provides: qt-components-lomiri,
Description: Qt 5 Components for Lomiri - Components QML plugin
 Qt 5 Components for Lomiri offers a set of reusable user interface
 components for Qt Quick 2 / QML.
 .
 This package contains the Lomiri Components QML plugin.

Package: qml-module-lomiri-components-labs
Architecture: any
Multi-Arch: same
Depends: ${fonts-ubuntu},
         ${fonts-noto},
         liblomirigestures5t64 (= ${binary:Version}),
         liblomirimetrics5t64 (= ${binary:Version}),
         liblomiritoolkit5t64 (= ${binary:Version}),
         libqt5svg5,
         lomiri-ui-toolkit-theme (= ${binary:Version}),
         qml-module-lomiri-performancemetrics,
         qml-module-qtfeedback,
         qml-module-qtgraphicaleffects,
         qml-module-qtquick-layouts,
         qml-module-qtquick-window2,
         qml-module-qtquick2,
         suru-icon-theme,
         ${misc:Depends},
         ${shlibs:Depends},
Conflicts: qt-components-lomiri-labs,
Replaces: qt-components-lomiri-labs,
Provides: qt-components-lomiri-labs,
Description: Qt 5 Components Labs for Lomiri - Components QML plugin
 Qt 5 Components Labs for Lomiri offers a set of non-released and mostly
 unstable user interface components for Qt Quick 2 / QML.
 .
 This package contains the Lomiri Components Labs QML plugin.

Package: qml-module-lomiri-layouts
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
Breaks: qtdeclarative5-lomiri-ui-toolkit-plugin (<< 1.3.3000~),
Replaces: qtdeclarative5-lomiri-ui-toolkit-plugin (<< 1.3.3000~),
Description: Qt 5 Components for Lomiri - Layouts QML plugin
 Qt 5 Components for Lomiri offers a set of reusable user interface
 components for Qt Quick 2 / QML.
 .
 This package contains the Lomiri Layouts QML plugin.

Package: qml-module-lomiri-test
Architecture: any
Multi-Arch: same
Depends: qml-module-lomiri-components,
         qml-module-qttest | qtdeclarative5-test-plugin,
         ${misc:Depends},
         ${shlibs:Depends},
Breaks: qtdeclarative5-lomiri-ui-toolkit-plugin (<< 1.3.3000~),
Replaces: qtdeclarative5-lomiri-ui-toolkit-plugin (<< 1.3.3000~),
Description: Qt 5 Components for Lomiri - Test QML plugin
 Qt 5 Components for Lomiri offers a set of reusable user interface
 components for Qt Quick 2 / QML.
 .
 This package contains the Lomiri Test QML plugin.

Package: qml-module-lomiri-performancemetrics
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
Breaks: qtdeclarative5-lomiri-ui-toolkit-plugin (<< 1.3.3000~),
Replaces: qtdeclarative5-lomiri-ui-toolkit-plugin (<< 1.3.3000~),
Description: Qt 5 Components for Lomiri - PerformanceMetrics QML plugin
 Qt 5 Components for Lomiri offers a set of reusable user interface
 components for Qt Quick 2 / QML.
 .
 This package contains the Lomiri PerformanceMetrics QML plugin.

Package: qml-module-lomiri-metrics
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
Breaks: qtdeclarative5-lomiri-ui-toolkit-plugin (<< 1.3.3000~),
Replaces: qtdeclarative5-lomiri-ui-toolkit-plugin (<< 1.3.3000~),
Description: Qt 5 Components for Lomiri - Metrics QML plugin
 Qt 5 Components for Lomiri offers a set of reusable user interface
 components for Qt Quick 2 / QML.
 .
 This package contains the Lomiri Metrics QML plugin.

Package: liblomirigestures5t64
Provides: ${t64:Provides}
Replaces: liblomirigestures5
Breaks: liblomirigestures5 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Lomiri gestures Qt 5 library for Lomiri UI Toolkit
 Qt 5 Components for Lomiri offers a set of reusable user interface
 components for Qt Quick 2 / QML.
 .
 Library supporting Gesture recognition for Lomiri UI Toolkit
 Classes for SwipeArea, and for Lomiri Gestures in general.

Package: liblomirigestures-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: liblomirigestures5t64 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: Lomiri gestures library development files
 Qt 5 Components for Lomiri offers a set of reusable user interface
 components for Qt Quick 2 / QML.
 .
 This package contains the development files for
 Lomiri gestures library with SwipeArea

Package: liblomirigestures5-private-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: liblomirigestures-dev (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: Lomiri gestures Qt 5 library private development files
 Qt 5 Components for Lomiri offers a set of reusable user interface
 components for Qt Quick 2 / QML.
 .
 This package contains the private development files for
 Lomiri gestures library with SwipeArea

Package: liblomirimetrics5t64
Provides: ${t64:Provides}
Replaces: liblomirimetrics5
Breaks: liblomirimetrics5 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Lomiri metrics Qt 5 library for Lomiri UI Toolkit
 Qt Components for Lomiri offers a set of reusable user interface
 components for Qt Quick 2 / QML.
 .
 Library for monitoring QtQuick 2 applications

Package: liblomirimetrics-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: liblomirimetrics5t64 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: Lomiri metrics Qt 5 library development files
 Qt 5 Components for Lomiri offers a set of reusable user interface
 components for Qt Quick 2 / QML.
 .
 This package contains the development files for the
 Lomiri metrics library

Package: liblomirimetrics5-private-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: liblomirimetrics-dev (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: Lomiri metrics Qt 5 library private development files
 Qt 5 Components for Lomiri offers a set of reusable user interface
 components for Qt Quick 2 / QML.
 .
 This package contains the private development files for
 the Lomiri metrics library

Package: liblomiritoolkit5t64
Provides: ${t64:Provides}
Replaces: liblomiritoolkit5
Breaks: liblomiritoolkit5 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Lomiri toolkit common Qt 5 library for Lomiri UI Toolkit
 Qt 5 Components for Lomiri offers a set of reusable user interface
 components for Qt Quick 2 / QML.
 .
 Contains components and helper classes that are shared between the
 Lomiri QML plugins

Package: liblomiritoolkit-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: liblomiritoolkit5t64 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: Lomiri toolkit common Qt 5 library development files
 Qt 5 Components for Lomiri offers a set of reusable user interface
 components for Qt Quick 2 / QML.
 .
 This package contains the development files for
 Lomiri toolkit common library

Package: liblomiritoolkit5-private-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: liblomiritoolkit-dev (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: Lomiri toolkit common Qt 5 library private development files
 Qt 5 Components for Lomiri offers a set of reusable user interface
 components for Qt Quick 2 / QML.
 .
 This package contains the private development files for

=== debian/rules ===
#!/usr/bin/make -f

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
include /usr/share/dpkg/buildflags.mk

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1
export DPKG_GENSYMBOLS_CHECK_LEVEL=4

export HOME := $(shell realpath .)

include /usr/share/dpkg/architecture.mk

# Enforce -Werror for an upstream build.
CONFIGURE_OPTS_QT5 :=
CONFIGURE_OPTS_QT6 :=

ifneq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
	# Cross compiling
	CONFIGURE_OPTS_QT5 += "CONFIG+=no_docs" "CONFIG+=cross_compile"
	CONFIGURE_OPTS_QT6 += # "CONFIG+=cross_compile"
endif

# Skip tests on the archs they are known to be flaky  with current configuration
testskip_architectures := armhf powerpc ppc64el s390x

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure --builddirectory=build-qt6 --buildsystem=cmake -- \
		$(CONFIGURE_OPTS_QT6) \
		..
	dh_auto_configure --builddirectory=build-qt5 --buildsystem=qmake -- \
		CONFIG+=debian_build \
		$(CONFIGURE_OPTS_QT5) \
		QMAKE_CFLAGS="$(CFLAGS)" \
		QMAKE_CXXFLAGS="$(CXXFLAGS)" \
		QMAKE_LFLAGS="${LDFLAGS}" \
		..
	dh_auto_configure --sourcedirectory=tests/autopilot --buildsystem=pybuild

override_dh_auto_build:
	dh_auto_build --builddirectory=build-qt6 --buildsystem=cmake ..
	dh_auto_build --builddirectory=build-qt5 --buildsystem=qmake ..
ifeq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
	dh_auto_build --builddirectory=build-qt5 --buildsystem=qmake -- docs ..
endif

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	mkdir -p debian/tmp/home/run
	chmod +x tests/xvfb.sh
ifneq (,$(filter $(DEB_HOST_ARCH),$(testskip_architectures)))
	-env UITK_BUILD_ROOT=$(CURDIR)/build-qt6 tests/xvfb.sh dh_auto_test --no-parallel --builddirectory=build-qt6 --buildsystem=cmake
else
	-env UITK_BUILD_ROOT=$(CURDIR)/build-qt6 tests/xvfb.sh dh_auto_test  --no-parallel --builddirectory=build-qt6 --buildsystem=cmake
endif
ifneq (,$(filter $(DEB_HOST_ARCH),$(testskip_architectures)))
	-env UITK_BUILD_ROOT=$(CURDIR)/build-qt5 tests/xvfb.sh dh_auto_test --no-parallel --builddirectory=build-qt5 --buildsystem=qmake
else
	env UITK_BUILD_ROOT=$(CURDIR)/build-qt5 tests/xvfb.sh dh_auto_test  --no-parallel --builddirectory=build-qt5 --buildsystem=qmake
endif
endif

override_dh_auto_install:
	dh_auto_install --no-parallel --builddirectory=build-qt6 --buildsystem=cmake ..
	dh_auto_install --no-parallel --builddirectory=build-qt5 --buildsystem=qmake ..
	rm -Rf debian/tmp/usr/include/*/LomiriGestures-Qt6/private/*_p.h
	rm -Rf debian/tmp/usr/include/*/LomiriMetrics-Qt6/private/*_p.h
	rm -Rf debian/tmp/usr/include/*/LomiriSystemInfo-Qt6/private/*_p.h
	rm -Rf debian/tmp/usr/include/*/LomiriToolkit-Qt6/private/*_p.h

override_dh_install:
ifeq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
	mkdir -p debian/tmp/`qmake -query QT_INSTALL_DOCS`/qch
	mkdir -p debian/tmp/usr/share/lomiri-ui-toolkit/doc
	cp -r $(CURDIR)/build-qt5/documentation/*qch debian/tmp/`qmake -query QT_INSTALL_DOCS`/qch
else
	# Add empty qmltypes files
	for module in "Components" "Components/Labs" "Components/Styles" "Layouts" "Metrics" "PerformanceMetrics"; \
	do \
		touch debian/tmp/`qmake -query QT_INSTALL_QML`/Lomiri/$$module/plugins.qmltypes; \
	done
endif
	rm -f debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/*.la

	# Drop QML types used to test apicheck only
	rm -f debian/tmp/usr/lib/*/qt*/qml/Extinct/Animals/*

	# drop lomiri-ui-toolkit-autopilot files, not buildable on non-Ubuntu systems
	rm -f  debian/tmp/usr/lib/*/lomiri-ui-toolkit/apicheck
	rm -Rf debian/tmp/usr/lib/python3

	# remove Qt 6 examples
	rm -rf debian/tmp/usr/lib/*/qt6/examples

	# remove Qt 6 apicheck for now
	rm -f debian/tmp/usr/libexec/lomiri-ui-toolkit/apicheck-qt6

	dh_install

ifeq ($(shell dpkg-vendor --derives-from Ubuntu && echo yes),yes)
SUBST_VAR := -Vfonts-ubuntu=fonts-ubuntu -Vfonts-noto=
else
SUBST_VAR :=  -Vfonts-noto=fonts-noto-core,fonts-noto-mono -Vfonts-ubuntu=
endif

override_dh_gencontrol:
	dh_gencontrol -- $(SUBST_VAR)

override_dh_auto_clean:
	-dh_auto_clean --builddirectory=build-qt6 --buildsystem=cmake ..
	-dh_auto_clean --builddirectory=build-qt5 --buildsystem=qmake ..

	# Qt / qmake creates <FolderName>.version files which don't
	# get clean-up properly by 'make distclean'
	-find . -name '*.version' -delete

	# Delete additional files
	rm -rvf \
	       .cache/ \
	       .config/ \
	       .local/ \
	       .pybuild/ \
	       po/*.mo \
	       examples/lomiri-ui-toolkit-gallery/po/*.mo \
	       xvfb.err \
	       ;

include /usr/share/dpkg/pkg-info.mk

PKD   = $(word 1,$(abspath $(dir $(MAKEFILE_LIST))))
PKG   = $(DEB_SOURCE)
UVER  = $(shell echo $(DEB_VERSION) | cut -d "-" -f1)
DTYPE = +dfsg
VER  ?= $(subst $(DTYPE),,$(UVER))

UURL = https://gitlab.com/ubports/development/core/lomiri-ui-toolkit.git
UREV = $(shell echo $(VER) | cut -d"." -f4)

## http://wiki.debian.org/onlyjob/get-orig-source
.PHONY: get-orig-source
get-orig-source: $(PKG)_$(VER)$(DTYPE).orig.tar.xz $(info I: $(PKG)_$(VER)$(DTYPE))
	@

$(PKG)_$(VER)$(DTYPE).orig.tar.xz: $(info I: GIT Revision=$(UREV))
	$(if $(wildcard $(PKG)-$(VER)),$(error $(PKG)-$(VER) exist, aborting..))
	@echo "# Downloading..."
	git clone $(UURL) $(PKG)-$(VER) \
	   || $(RM) -r $(PKG)-$(VER)
	cd $(PKG)-$(VER) \
	   && git checkout "$(UREV)" \
	   && ( echo "# Generating ChangeLog..." \
	      ; git --no-pager log --format="%ai %aN (%h) %n%n%x09*%w(68,0,10) %s%n" > ChangeLog \
	      ; touch -d "$$(git log -1 --format='%ci')" ChangeLog) \
	   && echo "# Setting times..." \
	   && for F in $$(git ls-tree -r --name-only HEAD); do touch --no-dereference -d "$$(git log -1 --format="%ai" -- $$F)" "$$F"; done \
	   && echo "# Cleaning-up..." \
	   && rm -rf documentation/autopilot-helpers/_build \
	   && rm -rf debian \
	   && rm -rf .git .git*
	@echo "# Packing..."
	find -L "$(PKG)-$(VER)" -xdev -type f -print | sort \
	   | XZ_OPT="-6v" tar -caf "../$(PKG)_$(VER)$(DTYPE).orig.tar.xz" -T- --owner=root --group=root --mode=a+rX \
	   && $(RM) -r "$(PKG)-$(VER)"

=== debian/watch ===
version=4
opts="mode=git, pgpmode=none,  pretty=1.3.6000~git%cd.%h, repacksuffix=+dfsg, dversionmangle=s/\+dfsg//" \
https://gitlab.com/ubports/development/core/lomiri-ui-toolkit.git heads/personal/gberh/qt68-cmake debian uupdate
